<!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <!--=============== BOXICONS ===============-->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/boxicons@latest/css/boxicons.min.css">

        <!--=============== CSS ===============-->
        <link rel="stylesheet" href="assets/css/styles.css">
        <!--=============== Julie CSS ===============-->
        <title>FARMWISE IOT PLATFORM</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <script src="https://code.highcharts.com/highcharts.js"></script>
        <script src="js/mqttws31.js" type="text/javascript"></script>
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        <script src="js/config.js" type="text/javascript"></script>
        <link rel="stylesheet" type="text/css" href="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.css" />
        <script type="text/javascript" src="https://cdn.jsdelivr.net/npm/daterangepicker/daterangepicker.min.js"></script>
      <!-- Add the font-awesome stylesheet to the head of your HTML -->
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
      <link rel="stylesheet"href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"/>
        <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"></script>
         <!-- Bootstrap CSS -->
     <!-- <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css">-->

      <style>

          .widget-container {
            display: flex;
            flex-wrap: wrap;
            justify-content: space-between;
            width: 100%;
            max-width: 1200px;
            margin: 0 auto;
          }

          .temp-widget {
            flex-basis: calc((100% - 30px) / 4); /* 4 widgets in the first row */
            margin-bottom: 20px;
            background-color: #ffffff;
            padding: 10px;
            border: 1px solid #e3e3e3;
            text-align: center;
          }

          @media (max-width: 991px) {
            .temp-widget {
              flex-basis: calc((100% - 20px) / 3); /* 3 widgets in the second row */
            }
          }

          @media (max-width: 767px) {
            .temp-widget {
              flex-basis: calc((100% - 10px) / 2); /* 2 widgets in each row */
            }
          }
          
          .container2 {
          display: flex;
          flex-direction: row;
        }

        #mapid {
          height: 250px;
          width: 40%;
        }

        #pestdetection {
          width: 50%;
          margin-left: 20px; /* add margin to the left */
        }
              </style>
    </head>
    <body>
        <!--=============== HEADER ===============-->
        <header class="header" id="header">
            <nav class="nav container">
                <a href="#" class="nav__logo">FarmWise</a>

                <div class="nav__menu" id="nav-menu">
                    <ul class="nav__list">
                        <li class="nav__item">
                              <a href="index.html" class="nav__link">
                                <i class='bx bx-home-alt nav__icon'></i>
                                <span class="nav__name">Home</span>
                            </a>
                        </li>
                        
                        <li class="nav__item">
                            <a href="prediction.html" class="nav__link">
                                <i class='bx bx-user nav__icon'></i>
                                <span class="nav__name">Predictions</span>
                            </a>
                        </li>

                        <li class="nav__item">
                             <a href="weather.html" class="nav__link">
                                <i class='bx bx-book-alt nav__icon'></i>
                                <span class="nav__name">Weather</span>
                            </a>
                        </li>

                        <!--<li class="nav__item">
                            <a href="#portfolio" class="nav__link">
                                <i class='bx bx-briefcase-alt nav__icon'></i>
                                <span class="nav__name">Portfolio</span>
                            </a>
                        </li>-->

                        <li class="nav__item">
                            <a href="#contactme" class="nav__link">
                                <i class='bx bx-message-square-detail nav__icon'></i>
                                <span class="nav__name">Contactme</span>
                            </a>
                        </li>
                    </ul>
                </div>

                <img src="assets/img/perfil.png" alt="" class="nav__img">
            </nav>
        </header>

        <main>
            <!--=============== HOME ===============-->
            <section class="container section section__height" id="home">
	<div class="container2">
          <div id="pestdetection">        
          <select id="model-selector">
            <option value="inception">Inception Model</option>
            <option value="coco">COCO-SSD Model</option>
            <option value="keras">Keras Model</option>
            <option value="custom">Custom Model</option>
            <option value="yolo">Yolo Model</option>
          </select>
          
            <h1>Vegetable Pest Detection</h1>
            <form id="pestForm" enctype="multipart/form-data" method="POST" action="/detect">
              <input type="file" name="image">
              <button type="submit2">Detect pests</button>
            </form>
            <div id="response"></div>
            <div id="image-container">
             <canvas id="my-canvas" width="200" height="200"></canvas>
            </div>
          </div>
        </div>
        
      <div id="weather"></div>
     <script type="text/javascript">
      var chart;
      var mqtt;
      var topic = "juliesundar/codettes/01"; // Specify the topic here
      var responseObject = {}; // define responseObject variable
      var reconnectTimeout = 2000;

 
    function MQTTconnect() {
	if (typeof path == "undefined") {
		path = '/mqtt';
	}
	mqtt = new Paho.MQTT.Client(
			host,
			port,
			path,
			"web_" + parseInt(Math.random() * 100, 10)
	);
        var options = {
            timeout: 3,
            useSSL: useTLS,
            cleanSession: cleansession,
            onSuccess: onConnect,
            onFailure: function (message) {
                $('#status').val("Connection failed: " + message.errorMessage + "Retrying");
                setTimeout(MQTTconnect, reconnectTimeout);
            }
        };

        mqtt.onConnectionLost = onConnectionLost;
        mqtt.onMessageArrived = onMessageArrived;

        if (username != null) {
            options.userName = username;
            options.password = password;
        }
        console.log("Host="+ host + ", port=" + port + ", path=" + path + " TLS = " + useTLS + " username=" + username + " password=" + password);
        mqtt.connect(options);
    }

function onConnect() {
    $('#status').val('Connected to ' + host + ':' + port + path);
    // Connection succeeded; subscribe to our topic
    mqtt.subscribe(topic, {qos: 0});
    $('#topic2').val(topic);

    // Set up chart
    chart = Highcharts.chart('container', {
      chart: {
        type: 'line',
        turboThreshold: 10000, // set to 0 to disable thresholding and display all points
         scrollablePlotArea: {
          minWidth: 600,
          scrollPositionX: 1
        }
      },
      title: {
        text: 'Sensor Data'
      },
      xAxis: {
        type: 'datetime',
        title: {
          text: 'Timestamp'
        }
      },
      yAxis: [{
        title: {
          text: 'Temperature'
        }
      }, {
        title: {
          text: 'Humidity'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Soil Moisture'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Salt'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Light'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Battery'
        },
        opposite: true // display on opposite side of chart
      }],
      series: [{
        name: 'Temperature',
        data: [],
        yAxis: 0 // use the first yAxis (index 0) for this series
      }, {
        name: 'Humidity',
        data: [],
        yAxis: 1 // use the second yAxis (index 1) for this series
      }, {
        name: 'Soil Moisture',
        data: [],
        yAxis: 2 // use the third yAxis (index 2) for this series
      }, {
        name: 'Salt',
        data: [],
        yAxis: 3 // use the fourth yAxis (index 3) for this series
      }, {
        name: 'Light',
        data: [],
        yAxis: 4 // use the fifth yAxis (index 4) for this series
      }, {
        name: 'Battery',
        data: [],
        yAxis: 5 // use the sixth yAxis (index 5) for this series
      }]
    });
}

  function onConnectionLost(responseObject) {
  setTimeout(MQTTconnect, reconnectTimeout);
  $('#status').val("Connection lost: " + responseObject.errorMessage + ". Reconnecting");
}

function onMessageArrived(message) {
  var topic = message.destinationName;
  var payload = message.payloadString;
  $('#ws').prepend('<li>' + topic + ' = ' + payload + '</li>');
  console.log("Message received: " + payload);

  
  // Parse message data
  var data = JSON.parse(payload);
  var timestamp = new Date().getTime();
  var temp = parseFloat(data.temp);
  var humid = parseFloat(data.humid);
  var soil = parseFloat(data.soil);
  var salt = parseFloat(data.salt);
  var light = parseFloat(data.light);
  var batt = parseFloat(data.batt);
  
  //Widgets
  // Get all the temp-data elements in the widget container
// Get all the widget containers
const widgetContainers = document.querySelectorAll('.widget-container');

// Loop through each widget container and update the widget data
widgetContainers.forEach(widgetElement => {
  widgetElement.querySelector('.temp-data').textContent = data.temp;
  
  // Update humidity data
  widgetElement.querySelector('.humid-data').textContent = data.humid;
  
  // Update soil data
  widgetElement.querySelector('.soil-data').textContent = data.soil;
  
  // Update salt data
  widgetElement.querySelector('.salt-data').textContent = data.salt;
  
  // Update light data
  widgetElement.querySelector('.light-data').textContent = data.light;
  
  // Update battery data
  widgetElement.querySelector('.batt-data').textContent = data.batt;
});

  chart.series[0].addPoint([Date.now(), data.temp]);
  chart.series[1].addPoint([Date.now(), data.humid]);
  chart.series[2].addPoint([Date.now(), data.soil]);
  chart.series[3].addPoint([Date.now(), data.salt]);
  chart.series[4].addPoint([Date.now(), data.light]);
  chart.series[5].addPoint([Date.now(), data.batt]);

  // Redraw the chart
  chart.redraw();

  // Update the chart based on the toggle switch
  if ($("#toggle-switch").is(":checked")) {
    // Display historical data
    var startDate = new Date($("#start-date").val());
    var endDate = new Date($("#end-date").val());
    chart.xAxis[0].setExtremes(startDate.getTime(), endDate.getTime());
  } else {
    // Display live data
    chart.xAxis[0].setExtremes(); // Reset the x-axis extremes to display all data
  }
  
}

$(document).ready(function() {
  MQTTconnect();
});

function fetchData(start, end) {
  console.log('fetchData called with start:', start, 'end:', end);
  const url = `/data/chart-data?start=${start.toISOString()}&end=${end.toISOString()}`;  
  console.log('fetchData url:', url);
  fetch(url)
    .then(response => response.json())
    .then(data => {
      console.log('fetchData data:', data);
      const chartData = data.map((obj) => ({
        x: new Date(obj.msg.timestamp).getTime(),
        y: [obj.msg.temp, obj.msg.humid, obj.msg.soil, obj.msg.salt, obj.msg.light, obj.msg.battery],
      }));
      console.log('fetchData chartData:', chartData);
      chart.series[0].setData(chartData.map(obj => [obj.x, obj.y[0]]));
      chart.series[1].setData(chartData.map(obj => [obj.x, obj.y[1]]));
      chart.series[2].setData(chartData.map(obj => [obj.x, obj.y[2]]));
      chart.series[3].setData(chartData.map(obj => [obj.x, obj.y[3]]));
      chart.series[4].setData(chartData.map(obj => [obj.x, obj.y[4]]));
      chart.series[5].setData(chartData.map(obj => [obj.x, obj.y[5]]));
    })
    .catch(error => console.error(error));
}

function handleSubmit(event) {
    event.preventDefault();
    const start = new Date(document.getElementById('start-date').value);
    const end = new Date(document.getElementById('end-date').value);
    console.log(start, end);
    fetchData(start, end);
}

    const myform = document.getElementById('date-form');
    myform.addEventListener('submit', handleSubmit);
    </script>
    	<script>
      // Define your API endpoint
      const apiUrl = "http://localhost:3000/data/";

      // Define your device ID
      const deviceId = "FarmBuddy_Sensor_Node02";

      // Create the Leaflet map object
      const mymap = L.map("mapid").setView([0, 0], 2);

      // Load the map tiles from OpenStreetMap
      L.tileLayer(
        "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
        {
          attribution:
            'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>',
          maxZoom: 18,
        }
      ).addTo(mymap);

      // Define a custom icon for the marker
      const icon = L.icon({
        iconUrl:
          "https://cdn0.iconfinder.com/data/icons/small-n-flat/24/678111-map-marker-512.png",
        iconSize: [38, 38],
        iconAnchor: [22, 38],
        popupAnchor: [-3, -36],
      });

      // Make an API request to fetch data based on device ID
      fetch(apiUrl + deviceId)
        .then((response) => response.json())
        .then((data) => {
          // Loop through the data and add markers to the map
          data.forEach((d) => {
            if (d.msg && d.msg.location) {
              const marker = L.marker(
                [d.msg.location.latitude, d.msg.location.longitude],
                { icon: icon }
              ).addTo(mymap);

              // Add a popup to the marker with device ID and other data
              marker.bindPopup(
             `<b>Device ID:</b> ${d.deviceId}<br>
                                        <b>Latitude:</b> ${d.msg.location.latitude}<br>
                                        <b>Longitude:</b> ${d.msg.location.longitude}<br>
                                        <b>Temperature:</b> ${d.msg.temp}<br>
                                        <b>Humidity:</b> ${d.msg.humid}<br>
                                        <b>HeatIndex:</b> ${d.msg.heatIndex}<br>`
                                      );
                                    }
                                  });
                                })
                                .catch((error) => console.log(error));
            </script>
            
            <script>
    const pestform = document.querySelector('#pestForm');
    const responseDiv = document.querySelector('#response');
    const imageContainer = document.querySelector('#image-container');

    pestform.addEventListener('submit', async (event) => {
      event.preventDefault();
      responseDiv.innerHTML = 'Detecting pests...';
      imageContainer.innerHTML = '';

      const formData = new FormData(event.target);
      const response = await fetch('/detect', {
        method: 'POST',
        body: formData,
      });
      const data = await response.json();
      console.log(data);
      responseDiv.innerHTML = '';

     // if (data.pestsPresent) {
        const img = document.createElement('img');
        img.src = 'data:image/jpeg;base64,' + data.img;
        img.onload = () => {
          const canvas = document.createElement('canvas');
          /*canvas.width = img.width;
          canvas.height = img.height;*/
          canvas.width = 150;
          canvas.height = 150;
          const ctx = canvas.getContext('2d');
          ctx.drawImage(img, 0, 0,150,150);
          
          imageContainer.appendChild(canvas);
        };

        const p = document.createElement('p');
        p.textContent = ` Predicted diseases: ${data.diseases[0].disease}`;
        responseDiv.appendChild(p);
    });
  </script>
         <!--    <div>
      <div>Subscribed to <input type='text' id='topic2' disabled />
        Status: <input type='text' id='status' size="10" disabled /></div>
        <ul id='ws'"></ul>
        </div>-->
        <!-- Bootstrap JS -->
       <!-- <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js"></script>-->
            </section>

            <!--=============== ABOUT ===============-->
           

            <!--=============== SKILLS ===============-->
            

            <!--=============== PORTFOLIO ===============-->
          
            <!--=============== CONTACTME ===============-->
           
        </main>
        

        <!--=============== MAIN JS ===============-->
        <script src="assets/js/main.js"></script>
    </body>
</html>